<?php 
#===================================================
# ТРЕБОВАНИЯ
// !!! для корректной работы скрипта необходима версия PHP 5.2.0 или выше !!!

#===================================================
# ДАННЫЕ ДЛЯ ПОДКЛЮЧЕНИЯ
$login = 'YOUR_LOGIN'; 							// логин
$key = 'YOUR_KEY'; 								// ключ доступа к API 
$url_json = 'http://positon.ru/api-json-v2/'; 	// Адрес API

#===================================================
# ФУНКЦИИ

// функция для отправки запросов к API
function api_request($method,$params){
	global $login,$key,$url_json;
	$params = json_encode($params);														// преобразование в JSON-формат
	$request = array('key'=>$key,'login'=>$login,'method'=>$method,'param'=>$params); 	// формирование запроса
	$request=http_build_query($request);												// преобразование запроса в строку
	$opts = array('http'=>array('method'=>"POST",'content'=>$request));					// параметры запроса
	$context = stream_context_create($opts);											// создание контекста потока
	$result = file_get_contents($url_json, 0, $context); 								// отправляем запрос и получаем ответ от сервера
	$result = json_decode($result,true); 												// преобразование JSON-формата  в массив
	return $result;												
}


// подготовка данных
$ProjectID=0; 
if (isset($_GET['id'])&&is_numeric($_GET['id'])&&$_GET['id']>0) $ProjectID=(int)$_GET['id'];
ob_start();

// вывод заголовка
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Просмотр проектов</title>

<style type="text/css">
<!--
	body,td,th { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #000000; }
	body { background-color: #FFFFFF; margin-left: 10px; margin-top: 10px; margin-right: 10px; margin-bottom: 10px; }
	a { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #3333CC; }
	a:link { text-decoration: none; }
	a:visited { text-decoration: none; color: #3333CC; }
	a:hover { text-decoration: underline; color: #CC0033; }
	a:active { text-decoration: none; color: #3333CC; }
	.clProjectList { width:700px; background:#999999; margin:5px 0px 5px 0px; cursor:default; }
	.clProjectList th { background:#FFCC33; font-weight:bold; text-align:center; vertical-align:middle; }
	.clProjectList tr {background:#FFFFFF; text-align:left; vertical-align:middle; }
	.clProjectList tr:hover td {background:#FFFFCC; color:#FF6600; font-weight:bold; font-size:14px; }
	.clProjectList input { width:100%; cursor:pointer; }
	.clProjectParam { width:345px; }
	.clProjectParam tr:hover td {background:#FFFFCC; color:#FF6600; font-weight:bold; font-size:12px; }
	.clProjectGroup tr:hover td {background:#FFFFCC; color:#FF6600; font-weight:bold; font-size:12px; }
	.clProjectPhrases { width:auto; min-width:700px; }
	.clProjectPhrases tr:hover td span { font-weight:normal; }
	.clPhrasesRegion {  font-weight:normal !important; font-size:11px !important; background:#FFE682 !important; }
	.clProjectTitle tr td { font-weight:bold; font-size:14px; }
	.msgSuccess { width:678px; background:#E8FFE8; border:#999999 1px solid; padding:10px; margin-bottom:18px; color:#006600; font-size:14px; }
	.msgError { width:678px; background:#FFE8E8; border:#999999 1px solid; padding:10px; margin-bottom:18px; color:#660000; font-size:14px; }
	.btnRefresh { position:absolute; width:205px; margin:2px 0px 0px 495px; }
	.btnRefresh input { width:100%; cursor:pointer; }
	.divLine { width:700px; height:0px; border-top:#FF6600 3px dotted; margin:15px 0px 15px 0px; }
-->
</style>

<script type="text/javascript"><!--
	function fProjectStart(id,name){
		if (confirm('Подтвердите запуск проверки проекта "'+name+'".')){
			document.getElementById('StartID').value=id;
			document.getElementById('frProjectStart').submit();
		}
	}
	function fProjectOpen(id){
		window.location.href='?id='+id;
	}
--></script>

</head>
<body>
<?php 

#===================================================
# ЗАПУСК ПРОЕКТА
if (isset($_POST['act'])&&$_POST['act']=='ProjectStart'&&isset($_POST['StartID'])&&is_numeric($_POST['StartID'])&&$_POST['StartID']>0){
	$StartID=(int)$_POST['StartID'];
	$Result=api_request('StartProject ',array("ProjectIDs" => array($StartID)));
	if ($Result['error']!=0){ $txt_content=ob_get_clean(); exit('<span style="color:#FF0000;">Метод <b>StartProject</b> вернул ошибку. <b>Код ошибки: '.$Result['error'].'</b></span>'); }
	$Result=$Result['data'][0];
	
	if ($Result['Result']=='success') echo '<div class="msgSuccess"><b>Проверка проекта запущена</b><br /><br />'.$Result['Description'].'</div>';
	if ($Result['Result']=='error') echo '<div class="msgError"><b>Ошибка при запуске проверки</b><br /><br />'.$Result['Description'].'</div>';
}

#===================================================
# ШАПКА СТРАНИЦЫ

// получаем баланс
$Balance=api_request('GetBalance',array(0));
if ($Balance['error']!=0){ $txt_content=ob_get_clean(); exit('<span style="color:#FF0000;">Метод <b>GetBalance</b> вернул ошибку. <b>Код ошибки: '.$Balance['error'].'</b></span>'); }

// вывод данных
?>
<div class="btnRefresh"><input type="button" name="button3" id="button3" value="Обновить страницу" onclick="window.location.href='?id=<?php echo $ProjectID; ?>';" /><br />
<?php if ($ProjectID>0){ ?><input type="button" name="button3" id="button3" value="Список проектов" style="margin-top:5px;" onclick="window.location.href='?id=0';" /><?php } ?>
</div>
<table border="0" cellspacing="1" cellpadding="2">
	<tr>
		<td align="right" valign="middle">Подключеный аккунт:</td>
		<td align="left" valign="middle"><span style="font-size:18px; color:#FF6600; font-weight:bold;"><?php echo $login; ?></span></td>
		<td width="30" align="left" valign="middle">&nbsp;</td>
		<td align="right" valign="middle">Юнитов на балансе: </td>
		<td align="left" valign="middle"><span style="font-size:18px; color:#FF6600; font-weight:bold;"><?php echo $Balance['data']['Units']; ?></span></td>
		<td align="left" valign="middle">
			<form id="frProjectStart" name="frProjectStart" method="post" action="">
				<input name="act" type="hidden" id="act" value="ProjectStart" />
				<input name="StartID" type="hidden" id="StartID" value="0" />
			</form>
		</td>
	</tr>
</table>
<br />
<?php

#===================================================
# СПИСОК ПРОЕКТОВ
if ($ProjectID==0){

// получаем список проектов с параметрами
$ProjectList=api_request('GetProjectsList',array(0));
if ($ProjectList['error']!=0){ $txt_content=ob_get_clean(); exit('<span style="color:#FF0000;">Метод <b>GetProjectsList</b> вернул ошибку. <b>Код ошибки: '.$ProjectList['error'].'</b></span>'); }

// вывод данных
?>
Список проектов:
<table border="0" cellpadding="3" cellspacing="1" class="clProjectList">
	<tr>
		<th width="30">№</th>
		<th>Название проекта</th>
		<th width="50">Фразы</th>
		<th width="90">Дата проверки</th>
		<th width="70">Проверка</th>
		<th width="120">Данные</th>
	</tr>
<?php foreach ($ProjectList['data'] as $Index=>$ProjectParam){ ?>
	<tr>
		<td align="center"><?php echo $ProjectParam['SortNumber']; ?></td>
		<td><?php echo $ProjectParam['Name']; ?></td>
		<td><?php echo $ProjectParam['PhrasesAll']; ?></td>
		<td align="center"><?php if ($ProjectParam['DateLastCheck']!='00.00.0000') echo $ProjectParam['DateLastCheck']; else echo '-'; ?></td>
		<td align="center"><?php if ($ProjectParam['CheckNow']==0){ ?>
		<input type="button" name="button" id="button" value="Запуск" onclick="fProjectStart(<?php echo $ProjectParam['ProjectID'].',\''.$ProjectParam['Name'].'\''; ?>);" /><?php } else { echo ''.$ProjectParam['CheckTimer']; } ?></td>
		<td><input type="button" name="button2" id="button2" value="Открыть" onclick="fProjectOpen(<?php echo $ProjectParam['ProjectID']; ?>);" /></td>
	</tr>
<?php } ?>
</table>
<?php 
} else {
#===================================================
# ПРОСМОТР ПРОЕКТА

// получаем список проектов с параметрами
$ProjectParams=api_request('GetProjectParams',array("ProjectID"=>$ProjectID,"ShowProject"=>1,"ShowGroups"=>1,"ShowPhrases"=>1,"ShowLastCheck"=>1,"ShowPreviousCheck"=>1));
if ($ProjectParams['error']!=0) { $txt_content=ob_get_clean(); exit('<span style="color:#FF0000;">Метод <b>GetProjectParams</b> вернул ошибку. <b>Код ошибки: '.$ProjectParams['error'].'</b></span>'); }
$ProjectParams=$ProjectParams['data'];

// вывод данных
?>
 
Просмотр проекта:
 
<table class="clProjectList clProjectTitle" border="0" cellspacing="1" cellpadding="3">
	<tr>
		<th width="30">№</th>
		<th>Название проекта</th>
		<th width="70">Проверка</th>
	</tr>
	<tr>
		<td align="center"><?php echo $ProjectParams['SortNumber']; ?></td>
		<td><?php echo $ProjectParams['Name']; ?></td>
		<td align="center"><input type="button" name="button4" id="button4" value="Запуск" onclick="fProjectStart(<?php echo $ProjectParams['ProjectID'].',\''.$ProjectParams['Name'].'\''; ?>);" <?php if ($ProjectParams['CheckNow']==1) echo 'disabled="disabled"'; ?> /></td>
	</tr>
</table>
<table width="700" border="0" cellspacing="0" cellpadding="0" style="margin-bottom:-5px;">
	<tr>
		<td width="345"><table border="0" cellpadding="3" cellspacing="1" class="clProjectList clProjectParam">
			<tr>
				<th>Параметр</th>
				<th width="100">Значение</th>
			</tr>
			<tr>
				<td>Всего фраз в проекте</td>
				<td><?php echo $ProjectParams['PhrasesAll']; ?></td>
			</tr>
			<tr>
				<td>Режим проверки</td>
				<td><?php 
if ($ProjectParams['FrequencyMode']==1) echo 'Каждый день';
if ($ProjectParams['FrequencyMode']==2){
	if (strlen($ProjectParams['FrequencyDays'])==1) echo 'Раз в неделю';
	if (strlen($ProjectParams['FrequencyDays'])>1) echo strlen($ProjectParams['FrequencyDays']).' в неделю';
}
if ($ProjectParams['FrequencyMode']==0) echo 'По требованию';
				
				?></td>
			</tr>
			<tr>
				<td>Дата создания проекта</td>
				<td><?php echo $ProjectParams['DateCreate']; ?></td>
			</tr>
			<tr>
				<td> Дата актуальной проверки</td>
				<td><?php if ($ProjectParams['DateLastCheck']!='00.00.0000') echo '<strong>'.$ProjectParams['DateLastCheck'].'</strong>'; else echo 'Нет данных'; ?></td>
			</tr>
			<tr>
				<td>Время до завершения проверки</td>
				<td><?php if ($ProjectParams['CheckNow']==1) echo '<strong>'.$ProjectParams['CheckTimer'].'</strong>'; else echo 'Не запущена'; ?></td>
			</tr>
		</table></td>
		<td width="10">&nbsp;</td>
		<td width="345"><table border="0" cellpadding="3" cellspacing="1" class="clProjectList clProjectParam">
			<tr>
				<th>Параметр</th>
				<th width="100">Значение</th>
			</tr>
			<tr>
				<td>Улучшение позиций</td>
				<td><?php echo $ProjectParams['RequestsUp']; ?>&nbsp;&nbsp;<span style="font-size:11px; color:#339900;">&uarr;</span></td>
			</tr>
			<tr>
				<td>Ухудшение позиций</td>
				<td><?php echo $ProjectParams['RequestsDown']; ?>&nbsp;&nbsp;<span style="font-size:11px; color:#CE4B2B;">&darr;</span></td>
			</tr>
			<tr>
				<td>Видимость позиций</td>
				<td><?php if ($ProjectParams['RequestsAll']!=0) echo round($ProjectParams['RequestsVisibile']/$ProjectParams['RequestsAll']*100).' %'; else echo '0%'; ?></td>
			</tr>
			<tr>
				<td>Позиций в ТОП-3</td>
				<td><?php if ($ProjectParams['RequestsAll']!=0) echo $ProjectParams['RequestsTop3'].' ('.round($ProjectParams['RequestsTop3']/$ProjectParams['RequestsAll']*100).'%)'; else echo '0%'; ?></td>
			</tr>
			<tr>
				<td>Позиций в ТОП-10</td>
				<td><?php if ($ProjectParams['RequestsAll']!=0) echo $ProjectParams['RequestsTop10'].' ('.round($ProjectParams['RequestsTop10']/$ProjectParams['RequestsAll']*100).'%)'; else echo '0%'; ?></td>
			</tr>
		</table></td>
	</tr>
</table>
<?php foreach ($ProjectParams['Groups'] as $GroupParams_i=>$GroupParams ){ ?>
<div class="divLine"></div>
<table border="0" cellspacing="1" cellpadding="3" class="clProjectList clProjectGroup">
	<tr>
		<th width="30">№</th>
		<th>Название группы</th>
		<th width="70">Фразы</th>
		<th width="70">Видимость</th>
	</tr>
	<tr>
		<td align="center"><?php echo $GroupParams['SortNumber']; ?></td>
		<td><?php echo $GroupParams['Name']; ?></td>
		<td><?php echo $GroupParams['PhrasesAll']; ?></td>
		<td><?php if ($GroupParams['RequestsAll']!=0) echo round($GroupParams['RequestsVisibile']/$GroupParams['RequestsAll']*100).' %'; else echo '0%'; ?></td>
	</tr>
</table>
<table border="0" cellspacing="1" cellpadding="3" class="clProjectList clProjectGroup clProjectPhrases">
	<tr>
		<th width="30">№</th>
		<th style="min-width:270px;">Фраза</th>
		<th width="70">Статистика</th>
		<?php foreach ($GroupParams['Searchers'] as $Searchers_i=>$Searchers){ $Searchers_m=explode(' - ',$Searchers); ?><th width="70"><?php echo $Searchers_m[0]; ?></th><?php } ?>
	</tr>
	<tr>
		<th colspan="2" class="clPhrasesRegion">&nbsp;</th>
		<th class="clPhrasesRegion">Wordstat</th>
		<?php foreach ($GroupParams['Searchers'] as $Searchers_i=>$Searchers){ $Searchers_m=explode(' - ',$Searchers); ?><th class="clPhrasesRegion"><?php echo $Searchers_m[1]; ?></th><?php } ?>
	</tr>
<?php foreach ($GroupParams['Phrases'] as $Phrases_i=>$Phrases){ ?>
	<tr>
		<td align="center"><?php echo $Phrases['SortNumber']; ?></td>
		<td><div style="max-width:270px;"><?php echo $Phrases['Name']; ?></div></td>
		<td><?php if ($Phrases['Wordstat']!=-1) echo $Phrases['Wordstat']; else echo '-'; ?></td>
		<?php foreach ($GroupParams['Searchers'] as $Searchers_i=>$Searchers){ ?><td><?php 
		
$pLast=$Phrases['PositionsLast']['BySearchers'][$Searchers_i];
$pPrev=$Phrases['PositionsPrev']['BySearchers'][$Searchers_i];

$pDelt=abs($pPrev-$pLast);
$pOrient=0;

if ($pLast>0&&$pPrev>0){ 
	echo $pLast;
	if ($pLast<$pPrev) $pOrient=1;
	if ($pLast>$pPrev) $pOrient=-1;
	if ($pLast==$pPrev) $pOrient=0;
}
if ($pLast==0&&$pPrev>0){ echo $pLast;  $pOrient=-1; $pDelt='...'; }
if ($pLast>0&&$pPrev==0){ echo $pLast; $pOrient=1; $pDelt='...'; }
if ($pLast==0&&$pPrev==0){ echo $pLast; $pOrient=0; }
if ($pLast==-1){ echo '-'; $pOrient=0;}
if ($pLast>=0&&$pPrev==-1){ echo $pLast; $pOrient=0; }

if ($pOrient==1) echo '&nbsp;&nbsp;<span style="font-size:11px; color:#339900;">&uarr;'.$pDelt.'</span>';
if ($pOrient==-1) echo '&nbsp;&nbsp;<span style="font-size:11px; color:#CE4B2B;">&darr;'.$pDelt.'</span>';

		?></td><?php } ?>
	</tr>
<?php } ?>
</table>
<?php
}
?>
<div class="divLine"></div>
<table width="700" border="0" cellspacing="0" cellpadding="0">
	<tr>
		<td>&nbsp;</td>
		<td width="200"><input type="button" name="button3" id="button3" value="Вверх страницы" style="width:100%;" onclick="window.location.href='#top';" /></td>
	</tr>
</table>
<?php
}
?>
</body>
</html><?php $txt_content = ob_get_clean(); echo $txt_content; ?>